{
  fetchFromGitHub,
  lib,
  pkg-config,
  rustPlatform,
  stdenv,
}: let
  inherit (lib) optionals;
in
  rustPlatform.buildRustPackage rec {
    pname = "cargo-leptos";
    version = "0.2.20";

    src = fetchFromGitHub {
      owner = "leptos-rs";
      repo = pname;
      rev = "v0.2.20";
      hash = "sha256-45zus+mNOiWWbuF50XpMwc1B6Uoy5E1kUQmtdGVc46g=";
    };

    cargoHash = "sha256-54CRNSDWdqD582Vv6d8snYEJrpkQ2Cvp8sjgQ6BcvHY=";

    # https://github.com/leptos-rs/cargo-leptos#dependencies
    buildFeatures = ["no_downloads"]; # cargo-leptos will try to install missing dependencies on its own otherwise
    doCheck = false; # Check phase tries to query crates.io

    meta = with lib; {
      description = "A build tool for the Leptos web framework";
      homepage = "https://github.com/leptos-rs/cargo-leptos";
      changelog = "https://github.com/leptos-rs/cargo-leptos/releases/tag/${version}";
      license = with licenses; [mit];
      maintainers = with maintainers; [benwis];
    };
  }
