use emacs::{defun, Env, IntoLisp, Result, Value};

// Emacs won't load the module without this.
emacs::plugin_is_GPL_compatible!();

// Register the initialization hook that Emacs will call when it loads the module.
#[emacs::module(separator = "/")]
fn init(env: &Env) -> Result<Value<'_>> {
    env.message("Test loading!")?;

    env.message("Done loading!")
}

// #[defun]
// fn listify_vec(vector: Vector) -> Result<Value> {
//     let mut args = vec![];
//     for e in vector {
//         args.push(e)
//     }
//     vector.0.env.call("list", &args)
// }

// Define a function callable by Lisp code.
#[defun]
fn say_hello(env: &Env, name: String) -> Result<Value<'_>> {
    // env.message(&format!("Helloo    Broooooooo, {}!", name))
    env.call(
        "message",
        [format!("Henlo whatup, {}!", name).as_str().into_lisp(env)?],
    )
}

#[defun]
fn open_test_overlay(_env: &Env) -> Result<Value<'_>> {
    todo!()
}
